#include <bits/stdc++.h>

using namespace std;

int n,m;
int Doha[1000][1000];
int mini=0;

int main()
{
    int q;
    int rezultati[1000]={};
    cin>>n>>m;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            cin>>Doha[i][j];
    
    cin>>q;
    
    int bloki,blokj;
    for(int i=1;i<=q;i++)
    {
        cin>>bloki>>blokj;
        if(n==2)
        {
            if(bloki==1)
            {
                for(int j=1;j<m;j++) rezultati[i]+=Doha[j][2];
                rezultati[i]+=Doha[1][1];
            } 
            else 
            {
                for(int j=1;j<m;j++) rezultati[i]+=Doha[j][1];
                rezultati[i]+=Doha[n][m];
            }
        }
    }
    return 0;
}